<h1 align="center">Enquirer</h1>

<p align="center">
  <a href="https://npmjs.org/package/enquirer">
    <img src="https://img.shields.io/npm/v/enquirer.svg" alt="version">
  </a>
  <a href="https://travis-ci.org/enquirer/enquirer">
    <img src="https://img.shields.io/travis/enquirer/enquirer.svg" alt="travis">
  </a>
  <a href="https://npmjs.org/package/enquirer">
    <img src="https://img.shields.io/npm/dm/enquirer.svg" alt="downloads">
  </a>
</p>

<br>
<br>

<p align="center">
  <b>Stylish CLI prompts that are user-friendly, intuitive and easy to create.</b><br>
  <sub>>_ Prompts should be more like conversations than inquisitions▌</sub>
</p>

<br>

<p align="center">
  <sub>(Example shows Enquirer's <a href="#survey-prompt">Survey Prompt</a>)</a></sub>
  <img src="https://raw.githubusercontent.com/enquirer/enquirer/master/media/survey-prompt.gif" alt="Enquirer Survey Prompt" width="750"><br>
  <sub>The terminal in all examples is <a href="https://hyper.is/">Hyper</a>, theme is <a href="https://github.com/jonschlinkert/hyper-monokai-extended">hyper-monokai-extended</a>.</sub><br><br>
  <a href="#built-in-prompts"><strong>See more prompt examples</strong></a>
</p>

<br>
<br>

{%= format(include('docs/features.md')) %}

<br>

<p align="center">
  <b>>_ Ready to start making prompts your users will love? ▌</b><br>
  <img src="https://raw.githubusercontent.com/enquirer/enquirer/master/media/heartbeat.gif" alt="Enquirer Select Prompt with heartbeat example" width="750">
</p>

<br>
<br>

## ❯ Getting started

Get started with Enquirer, the most powerful and easy-to-use Node.js library for creating interactive CLI prompts. 

- [Install](#-install)
- [Usage](#-usage)
- [Enquirer](#-enquirer)
- [Prompts](#-prompts)
  * [Built-in Prompts](#-prompts)
  * [Custom Prompts](#-custom-prompts)
- [Key Bindings](#-key-bindings)
- [Options](#-options)
- [Release History](#-release-history)
- [Performance](#-performance)
- [About](#-about)

<br>

## ❯ Install
{%= format(include('docs/install.md')) %}

<br>

## ❯ Usage
{%= format(include('docs/usage.md')) %}

<br>

## ❯ Enquirer
{%= format(include('docs/overview.md')) %}

### Enquirer API
{%= apidocs('index.js') %}

<br>

## ❯ Prompts
{%= format(include('docs/prompts.md')) %}

<br>

## ❯ Key Bindings
{%= format(include('docs/key-bindings.md')) %}

<br>

{%= include('docs/footer.md') %}
